/* this is mainly for faking or replacing functions and variables from the
   FreeCiv source tree that
   1) aren't needed for the map editor, but are needed by functions
      which live in modules that _are_ needed
   2) are needed but come from civserver.c which also contains a main() */

#include "civ.h"

#include "registry.h"
#include "game.h"
#include "gamehand.h"

#include <stdio.h>


int is_server=1;
int rand_init=0;
char metaserver_info_line[255];
enum server_states server_state;


/***************************************************************************
load a save game
***************************************************************************/
void load_game(char *load_filename)
 {
  game_init();

  /* load a saved game */
  if(load_filename)
   {
    struct section_file file;
    if(!section_file_load(&file, load_filename))
     {
      fprintf(stderr, "Couldn't load savefile: %s", load_filename);
      exit(1);
     }
    game.scenario=game_load(&file);
    section_file_check_unused(&file, load_filename);
    section_file_free(&file);
    /* game.scenario: 0=normal savegame, 1=everything but players,
       2=just tile map and startpositions, 3=just tile map */
    if (game.scenario) /* we may have a scenario here */
     {
      if(game.nplayers) /* no, it's just a normal savegame */
       {
        game.scenario=0;
       }
     }
   }
 } /* load_game */


/***************************************************************************
save a save game
***************************************************************************/
void save_game(char *save_filename)
{
  struct section_file file;
  server_state=PRE_GAME_STATE;

  section_file_init(&file);

  game_save(&file);

  if(!section_file_save(&file, save_filename))
    fprintf(stderr,"Failed saving game as %s\n", save_filename);
  else
    fprintf(stderr,"Game saved as %s\n", save_filename);

  section_file_free(&file);
}


/*****************************************************************************
 fake functions from here on
*****************************************************************************/
void dealloc_id(int id)
 {
   return;
 }

struct city *find_city_by_id(int id)
 {
  return (struct city *) NULL;
 }

void player_save(struct player *plr, int plrno, struct section_file *file)
 {
  return;
 }

void player_load(struct player *plr, int plrno, struct section_file *file)
 {
  return;
 }

int city_refresh(struct city *pcity)
 {
  return 0;
 }

void create_unit(struct player *pplayer, int x, int y, enum unit_type_id type)
 {
  return;
 }

void send_unit_info(struct player *dest, struct unit *punit, int dosend)
 {
  return;
 }

void send_city_info(struct player *dest, struct city *pcity, int dosend)
 {
  return;
 }
