#include "events.h"
#include "draw.h"
#include "main.h"
#include "tools.h"

#include "game.h"


int pressed=FALSE;


/****************************************************************************
mouse button click event
****************************************************************************/
void press(GtkWidget *widget, GdkEventButton *ev)
 {
  switch(ev->button)
   {
    case 1:
      pressed=TRUE;
      if(current_tool->function_press != NULL)
       {
	(current_tool->function_press)(widget,
	    ev->x/TILE_WIDTH, ev->y/TILE_HEIGHT);
       }
    break;
    case 2:
      popit(ev, ev->x/TILE_WIDTH, ev->y/TILE_HEIGHT);
    break;
    case 3:
      if(current_tool->function_press == put_one_unit)
      country=(++country) % R_LAST;
      refresh_racelabel();
    break;
   }

 } /* press() */


/****************************************************************************
mouse move event
****************************************************************************/
void motion(GtkWidget *widget, GdkEventMotion *ev)
 {
  if( (pressed) && (current_tool->function_press != NULL))
   {
    (current_tool->function_press)(widget,
                                   ev->x/TILE_WIDTH, ev->y/TILE_HEIGHT);
   }
 } /* motion() */


/****************************************************************************
mouse button release event
****************************************************************************/
void release(GtkWidget *widget, GdkEventButton *ev)
 {
  pressed=FALSE;
 } /* release */


/****************************************************************************
expose events
****************************************************************************/
guint expose(GtkWidget *widget, GdkEventExpose *ev)
 {
  draw_units(widget, ev->area.x/TILE_WIDTH-1, ev->area.y/TILE_HEIGHT-1,
	     ev->area.width/TILE_WIDTH+1, ev->area.height/TILE_HEIGHT+1); 
  gdk_draw_pixmap(widget->window, widget->style->white_gc, pix_screen,
                  ev->area.x, ev->area.y,
                  ev->area.x, ev->area.y, ev->area.width, ev->area.height);
  return FALSE;
 } /* expose() */


guint expose_racelabel(GtkWidget *widget, GdkEventExpose *ev)
 {
  int tmpX, tmpY;

  tmpX=country%16;
  tmpY=14;
  gdk_window_clear(widget->window);
  gdk_gc_set_clip_origin(gc_tiles,(-tmpX)*TILE_WIDTH,(-tmpY)*TILE_HEIGHT);
  gdk_draw_pixmap(widget->window, gc_tiles, pix_tiles,
		  tmpX*TILE_WIDTH, tmpY*TILE_HEIGHT,0,0,
		  TILE_WIDTH, TILE_HEIGHT);
  return FALSE;
 } /* expose_racelabel() */


/*****************************************************************************
redraw the race label by generating a fake expose event
*****************************************************************************/
void refresh_racelabel()
 {
  GdkEventExpose tmp;

  tmp.area.x=0;
  tmp.area.y=0;
  tmp.area.width=TILE_WIDTH;
  tmp.area.height=TILE_HEIGHT;

  expose_racelabel(GTK_WIDGET(racelabel), &tmp);
 } /* refresh_racelabel() */
