#include "civedit.h"
#include "main.h"
#include "civ.h"
#include "tools.h"
#include "tiles.h"
#include "events.h"
#include "menu.h"
#include "draw.h"

#include "map.h"
#include "mapgen.h"
#include "genlist.h"


int TILE_WIDTH=30;
int TILE_HEIGHT=30;
int country=0;
static GtkWidget *terrainlabel;


/*****************************************************************************
main() - need I say more?
*****************************************************************************/
int main(int argc, char **argv)
 {
  GtkWidget *scroll;
  GtkWidget *box;
  GtkWidget *hbox;
  gtk_init(&argc, &argv);

/*
  genlist_init(&city_to_draw_list);
  city_font=gdk_font_load(DEFAULT_FONT);
*/

  create_tools_palette();

  win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(win), "FreeWorld - Cause the world should be free");
  gtk_window_set_default_size(GTK_WINDOW(win), 600,400);
  
  box = gtk_vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(win), box);
  
  create_menus(box);

  scroll=gtk_scrolled_window_new(NULL, NULL);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll),
				 GTK_POLICY_ALWAYS, GTK_POLICY_ALWAYS);

  da=(GtkDrawingArea *) gtk_drawing_area_new();
  gtk_drawing_area_size(da, map.xsize*TILE_WIDTH, map.ysize*TILE_HEIGHT); 
  gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scroll), GTK_WIDGET(da));

  gtk_signal_connect(GTK_OBJECT(da), "expose_event",
		      GTK_SIGNAL_FUNC(expose), NULL);
  gtk_signal_connect(GTK_OBJECT(da), "motion_notify_event",
		      GTK_SIGNAL_FUNC(motion), NULL);
  gtk_signal_connect(GTK_OBJECT(da), "button_press_event",
		      GTK_SIGNAL_FUNC(press), NULL);
  gtk_signal_connect(GTK_OBJECT(da), "button_release_event",
		      GTK_SIGNAL_FUNC(release), NULL);
  gtk_signal_connect(GTK_OBJECT(win), "delete_event",
		      GTK_SIGNAL_FUNC(gtk_main_quit), NULL);
  gtk_widget_set_events(GTK_WIDGET(da), GDK_BUTTON_PRESS_MASK
			 | GDK_KEY_PRESS_MASK | GDK_BUTTON_RELEASE_MASK
			 | GDK_EXPOSURE_MASK | GDK_POINTER_MOTION_MASK);

  gtk_box_pack_start(GTK_BOX(box), GTK_WIDGET(scroll), TRUE, TRUE, 5);

  hbox=gtk_hseparator_new ();
  gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, TRUE, 0);
  gtk_widget_show(hbox);

  hbox=gtk_hbox_new(FALSE, 0);

  gtk_box_pack_end(GTK_BOX(box), GTK_WIDGET(hbox), FALSE, FALSE, 5);
  racelabel=gtk_label_new("Terrain: ");
  gtk_box_pack_start(GTK_BOX(hbox), GTK_WIDGET(racelabel), FALSE, FALSE, 5);
  gtk_widget_show(GTK_WIDGET(racelabel)); 

  terrainlabel=gtk_label_new("Arctic ");
  gtk_box_pack_start(GTK_BOX(hbox), GTK_WIDGET(terrainlabel), FALSE, FALSE, 5);
  gtk_widget_show(GTK_WIDGET(terrainlabel)); 

  racelabel=gtk_label_new("Race: ");
  gtk_box_pack_start(GTK_BOX(hbox), GTK_WIDGET(racelabel), FALSE, FALSE, 5);
  gtk_widget_show(GTK_WIDGET(racelabel)); 

  racelabel=gtk_drawing_area_new();
  gtk_drawing_area_size(GTK_DRAWING_AREA(racelabel),TILE_WIDTH, TILE_HEIGHT);
  gtk_box_pack_start(GTK_BOX(hbox), GTK_WIDGET(racelabel), FALSE, FALSE, 5);
  gtk_signal_connect(GTK_OBJECT(racelabel), "expose_event",
		      GTK_SIGNAL_FUNC(expose_racelabel), NULL);

  gtk_widget_show(GTK_WIDGET(racelabel)); 


  gtk_widget_show(GTK_WIDGET(da)); 
  gtk_widget_show(GTK_WIDGET(scroll)); 
  gtk_widget_show(GTK_WIDGET(hbox));
  gtk_widget_show(GTK_WIDGET(box));
  gtk_widget_show(GTK_WIDGET(win));
  
  my_init(GTK_WIDGET(da));

  if(argc == 2)
   {
    odialog = gtk_file_selection_new("Open file...");
    gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(odialog)->cancel_button),
		       "clicked",(GtkSignalFunc) fs_cancel, odialog);
    gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(odialog)->ok_button),
		       "clicked",(GtkSignalFunc) open_ok, odialog);
    gtk_file_selection_set_filename(GTK_FILE_SELECTION(odialog), argv[1]);
    open_ok(NULL, GTK_FILE_SELECTION(odialog));
   }
  else
   {
    create_new_map(MAP_DEFAULT_WIDTH,MAP_DEFAULT_HEIGHT);
   }

  gtk_main();

  return 0;
 }


void terrain_label(const char *label)
 {
  if(terrainlabel!=NULL)
    gtk_label_set_text(GTK_LABEL(terrainlabel),label);
 }
