#ifndef __TOOLS_H__
#define __TOOLS_H__


#include "civedit.h"
#include "map.h"

#define NB_COLORS 12
#define TOOLS_NUMBER 4


enum ToolType
 {
  TOOLTYPE_SIMPLE,
  TOOLTYPE_LINE,
  TOOLTYPE_AREA
 };

typedef void (* ToolFunction) (GtkWidget *widget, int x, int y);

typedef struct _tool 
 {
  char *name;
  char **pixmap_data;
  GdkPixmap *pixmap;
  GdkBitmap *mask;
  enum ToolType type;
  char *tiptext;
  ToolFunction function_press;
  ToolFunction function_release;
  GtkWidget *button;
  int id;
 } Tool;

extern Tool tools[TOOLS_NUMBER];

Tool *current_tool;


typedef struct _couleur 
 {
  char *name;
  int parametre;
  GtkWidget *button;
  GdkPixmap *pix;
  int id;
 } Couleur;

extern int current_color;
extern Couleur couleurs[NB_COLORS];

GtkWidget *create_palette(void);
void make_colors(GtkWidget *widget);
void set_color(GtkWidget *widget, gpointer data);


void create_tools (GtkWidget *win, GtkWidget *parent);
void show_tools(void);
void tool_toggled (GtkWidget *widget, gpointer tool);
void put_one_tile (GtkWidget *widget, int x, int y);
void put_one_unit (GtkWidget *widget, int x, int y);
void create_tools_palette(void);
int destroyWindow(GtkWidget *widget, GdkEvent *ev, gpointer removedWidget);
void delete (GtkWidget *widget, gpointer data);
void show_tips(void);


#endif /* __TOOLS_H__ */
